/*
 * Colour stripping module for ShadowIRCd.
 */
#include "stdinc.h"
#include "handlers.h"
#include "client.h"
#include "ircd.h"
#include "numeric.h"
#include "common.h"
#include "s_misc.h"
#include "s_conf.h"
#include "s_serv.h"
#include "send.h"
#include "msg.h"
#include "parse.h"
#include "modules.h"
#include "channel.h"
#include "channel_mode.h"
#include "irc_string.h"
#include "hash.h"
#include "packet.h"
#include "hook.h"
#include "newconf.h"

int strip_colours(struct hook_privmsg_data *);
char *target_channel;

void
_modinit(void)
{
	hook_add_hook("client_message_preprocess", (hookfn *)strip_colours);
	register_umode('C', UMODE_NOCOLOUR, 0, 1);
}

void
_moddeinit(void)
{
	hook_del_hook("client_message_preprocess", (hookfn *)strip_colours);
}

const char *_version = "nenolod, version 3";

int
strip_colours(struct hook_privmsg_data *data)
{
	if (HasUmode(data->to, UMODE_NOCOLOUR))
		strip_colour(data->text);

	return 0;
}
